program deltamax;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  DllUnit;

{$R dm.res}

type
  DELTAMAX_ENCODE_OPTIONS = record
  lpszLicensedTo: LPCTSTR;
  lpszLicenseKey: LPCTSTR;
  nMemoryMax: Integer;
  nMemoryMaxPercent: Integer;
  nFreeMemoryMin: Integer;
  nLowMemMode: Integer;
  nFootprintSize: Integer;
  bAutoIncreaseFootprintSize: bool;
  bEnableMultiPass: bool;
  nMultiPassThreshold: Integer;
  nMultiPassMaxAdditionalPasses: Integer;
  pProgressCallback: longword;
  pMessageCallback: Integer;
  lpUserData: Pointer;
end;

var
  Data: PAnsiChar;
  pOptions: DELTAMAX_ENCODE_OPTIONS;

  ResourceLocation: HRSRC;
  ResourceSize: LongWord;
  ResourceHandle: THandle;
  ResourcePointer: Pointer;

  DeltaMAXInitEncodeOptions: procedure(pOptions: DELTAMAX_ENCODE_OPTIONS); cdecl;
  DeltaMAXEncode: function(szSource: LPCSTR; szTarget: LPCSTR; szDiff: LPCSTR; pOptions: DELTAMAX_ENCODE_OPTIONS): Integer; cdecl;

  DeltaMAX_Imports: array [0..1] of TImportItem = (
   (Name: 'DeltaMAXInitEncodeOptions'; PProcVar: @@DeltaMAXInitEncodeOptions),
   (Name: 'DeltaMAXEncode'; PProcVar: @@DeltaMAXEncode)
  );

  DeltaMax_Library: TLibInfo;

procedure Generate;
begin
  DeltaMAXInitEncodeOptions(pOptions);
  pOptions.lpszLicensedTo := 'none';
  pOptions.lpszLicenseKey := 'none';
  pOptions.nMemoryMax := 0;
  pOptions.nMemoryMaxPercent := 80;
  pOptions.nFreeMemoryMin := 8;
  pOptions.nLowMemMode := 1;
  pOptions.nFootprintSize := 0;
  pOptions.bAutoIncreaseFootprintSize := true;
  pOptions.bEnableMultiPass := false;
  pOptions.nMultiPassThreshold := 0;
  pOptions.nMultiPassMaxAdditionalPasses := 1;
  Data := 'bla-bla';
  pOptions.lpUserData := Data;

  DeltaMAXEncode('d:\1.txt','d:\2.txt','d:\3.diff',pOptions);
end;

procedure Load_DeltaMax_Engine;
begin
  ResourceLocation := FindResource(HInstance, pchar('DMAX'), RT_RCDATA);
  if ResourceLocation <> 0 then
  begin
    ResourceSize := SizeofResource(HInstance, ResourceLocation);
    if ResourceSize <> 0 then
    begin
      ResourceHandle := LoadResource(HInstance, ResourceLocation);
      if ResourceHandle <> 0 then
      begin
        ResourcePointer := LockResource(ResourceHandle);
        if ResourcePointer <> nil then
        begin
          DeltaMax_Library := xLoadLibrary(ResourcePointer, DeltaMax_Imports);
        end;
      end;
    end;
  end;
end;

begin
  Load_DeltaMax_Engine;
  Generate;
  xFreeLibrary(DeltaMax_Library);
end.
